window.onload = function() {
	var elements = document.getElementsByName("group");
	for (var i = 0; i < elements.length; i++) {
		elements[i].onclick = function() { visibleOnOff(this.id); }
	}

	var elements = document.getElementsByTagName("input");
	for (var i = 0; i < elements.length; i++) {
		if (elements[i].type == "checkbox") {
			switch (elements[i].value) {
			case "HostList":
				elements[i].onchange = function() { onchangeHostList(this); }
				break;
			case "Host":
				elements[i].onchange = function() { onchangeHost(this); }
				break;
			case "LogList":
				elements[i].onchange = function() { onchangeLogList(this); }
				break;
			case "Level":
				elements[i].onchange = function() { onchangeLevel(this); }
				break;
			case "Rule":
				elements[i].onchange = function() { onchangeRule(this); }
				break;
			default:
			}
		}
	}

	var button = document.getElementById("button");
	button.onclick = function() { onclickButton(this); }
}

function visibleOnOff(Name) {
	var elements = document.getElementsByName(Name);
	for (var i=0; i<elements.length; i++) {
		if (elements[i].className == "hidden") elements[i].className = "visible";
		else elements[i].className = "hidden";	
	}
}

function onchangeHostList(element) {
	var elements = document.getElementsByTagName("input");
	for (var i = 0; i < elements.length; i++) {
		if ((elements[i].type == "checkbox") && (elements[i].value == "Host")) {
			if (element.checked == true) elements[i].checked = true;
			else elements[i].checked = false;
		}
	}
	element.form.submit();
}

function onchangeHost(element) {
	var HostList = document.getElementById("HostList");
	if (HostList.checked == true) HostList.checked = false;
	element.form.submit();
}

function onchangeLogList(element) {
	var elements = document.getElementsByTagName("input");
	for (var i = 0; i < elements.length; i++) {
		if ((elements[i].type == "checkbox") && (elements[i].value == "Level")) {
			if (element.checked == true) elements[i].checked = true;
			else elements[i].checked = false;
		}
		if ((elements[i].type == "checkbox") && (elements[i].value == "Rule")) {
			if (element.checked == true) elements[i].checked = true;
			else elements[i].checked = false;
		}
	}
	element.form.submit();
}

function onchangeLevel(element) {
	var LogList = document.getElementById("LogList");
	if (LogList.checked == true) LogList.checked = false;
	var elements = document.getElementsByClassName(element.id);
	for (var i = 0; i < elements.length; i++) {
		if (element.checked == true) elements[i].checked = true;
		else elements[i].checked = false;
	}
	element.form.submit();
}

function onchangeRule(element) {
	var LogList = document.getElementById("LogList");
	if (LogList.checked == true) LogList.checked = false;
	var Level = document.getElementById(element.className);
	if (Level.checked == true) Level.checked = false;
	element.form.submit();
}

function onclickButton(element) {
	element.form.setAttribute("action","ArchivList.php");
	element.form.setAttribute("target","_blank");
	element.form.submit();
	element.form.setAttribute("action","ArchivFilter.php");
	element.form.setAttribute("target","_self");
}
