<?php
putenv("KRB5CCNAME={$_SERVER['KRB5CCNAME']}");
$NOTE = "";
#if ((! in_array("HostList", $_POST)) && (! in_array("Host", $_POST))) $_POST["HostList"] = "HostList";
#if ((! in_array("LogList", $_POST)) && (! in_array("Level", $_POST))  && (! in_array("Rule", $_POST))) $_POST["LogList"] = "LogList";

#$NOTE = serialize($_POST);

function makeIndex($fileName, $hostList) {
	$logFileName = "/var/ossec/logs/alerts/alerts.log";
	$mon = array("Jan"=>"01", "Feb"=>"02", "Mar"=>"03", "Apr"=>"04", "May"=>"05", "Jun"=>"06",
		"Jul"=>"07", "Aug"=>"08", "Sep"=>"09", "Oct"=>"10", "Nov"=>"11", "Dec"=>"12");

	$index = array();

	if ($fileName == "") {
		$index["archiv"] = $logFileName;
		$a = explode("** Alert ", file_get_contents($logFileName));
	} else {
		$index["archiv"] = $fileName;
		$a = explode("** Alert ", implode("", gzfile($fileName)));
	}
	$aMax = count($a);
	for ($i=1; $i<$aMax; $i++) {
		$s = explode("\n", $a[$i]);

		$ss = explode(": ", $s[0]);
			$timeindex = $ss[0];
			$sss = explode(" ", $ss[1]);
			$sss = explode("- ", $ss[1]);
			$groups = $sss[1];

		$ss = explode("->", $s[1]);
			$source = $ss[1];
			$sss = explode(" ", $ss[0]);
			$date = $sss[2].".".$mon[$sss[1]].".".$sss[0];
			$time = $sss[3];
			if (count($sss) < 6) {
				$hostname = $sss[4];
				$IP = "";
			} else {
				$IP = $sss[5];
				$hostname = $hostList[$IP];
			}
#echo($fileName."===".$hostname."---".$IP."\n");
		$ss = explode(") -> ", $s[2]);
			$description = str_replace("'", "", $ss[1]);
			$sss = explode(" ", $ss[0]);
			$rule = $sss[1];
			$level = $sss[3];

		$index["rules"][$rule]["groups"] = $groups;
		$index["rules"][$rule]["description"] = $description;
		if (isset($index["logs"][$hostname][$level][$rule])) {
			$n = count($index["logs"][$hostname][$level][$rule]);
			$index["logs"][$hostname][$level][$rule][$n] = $i;
		} else {
			$index["logs"][$hostname][$level][$rule][0] = $i;
		}
	}

	return($index);
}

$logDirName = "/var/ossec/logs/alerts";
$logFileName = "/var/ossec/logs/alerts/alerts.log";
$indexDirName = "/var/www/ossec/arch";
$alertsDirName = "/var/www/ossec/data/";
$alertsLevelFileName = "alerts.level";
$xmlFileName = "../data/ArchivFilter.xml";

$mon = array("Jan"=>"01", "Feb"=>"02", "Mar"=>"03", "Apr"=>"04", "May"=>"05", "Jun"=>"06",
	"Jul"=>"07", "Aug"=>"08", "Sep"=>"09", "Oct"=>"10", "Nov"=>"11", "Dec"=>"12");

$newArchivFilter = <<<XML
<?xml version='1.0' encoding='UTF-8'?>
<ArchivFilter>
</ArchivFilter>
XML;

$newArchivFilter = <<<XML
<?xml version='1.0' encoding='UTF-8'?>
<?xml-stylesheet type="text/xsl" href="ArchivFilter.xsl" media="screen"?>
<ArchivFilter>
</ArchivFilter>
XML;

$alertLevel = array(0,1,1,1,1,1,2,2,2,2,2,3,3,3,3,3);
if (is_readable($alertsDirName.$alertsLevelFileName)) {
	$alertLevel = unserialize(file_get_contents($alertsDirName.$alertsLevelFileName));
}

$hostList = array();
$u = array();
$command = <<<EOF
/var/ossec/bin/manage_agents -l|grep ID|awk -F, '{print $3}'|awk -F" " '{print "echo -n " $2 " e && host " $2}'|bash|awk -F" " '{print $1 "." $6}'|awk -F. '{print $1 "." $2 "."$3 "."$4 " "$5}'
EOF;
exec($command, $u);
foreach ($u as $v) {
	$uu = explode(" ", $v);
	$hostList[$uu[0]] = $uu[1];
}

file_put_contents($indexDirName.'/alerts.index', serialize(makeIndex("", $hostList)));
$dirYs = glob($logDirName."/*", GLOB_ONLYDIR);
foreach ($dirYs as $dirY) {
	$Y = basename($dirY);
	$dirMs = glob($dirY."/*", GLOB_ONLYDIR);
	foreach ($dirMs as $dirM) {
		$M = $mon[basename($dirM)];
		$filDs = glob($dirM."/*.log.gz");
		foreach ($filDs as $filD) {
			$a = explode("-", basename($filD));
			list($D, $s) = explode(".", basename($a[2],2));
			$fileName = $Y."-".$M."-".$D.".index";
			if (! is_file($indexDirName."/".$fileName)) {
				file_put_contents($indexDirName."/".$fileName, serialize(makeIndex($filD, $hostList)));
			}
		}
	}
}

$ruleList = array();
$hostList = array();
$logList = array();
$fileList = glob($indexDirName."/*.index");
foreach ($fileList as $file) {
	$a = unserialize(file_get_contents($file));
	if (is_file($a["archiv"])) {
		if (isset($a["rules"])) foreach ($a["rules"] as $rule=>$param) {
			if (! isset($ruleList[$rule])) $ruleList[$rule] = $param;
		}
		if (isset($a["logs"])) foreach ($a["logs"] as $hostname=>$levelList) {
			if (! isset($hostList[$hostname])) $hostList[$hostname] = 0;
			foreach ($levelList as $level=>$rules) {
				if (! isset($logList[$level])) $LogList[$level] = array();
				foreach ($rules as $rule=>$nnn) {
					if (! isset($logList[$level][$rule])) $logList[$level][$rule] = 0;
					if ((in_array("HostList", $_POST) || array_key_exists($hostname, $_POST))
					&& (in_array("LogList", $_POST) || array_key_exists("Level".$level, $_POST)
					|| array_key_exists($rule, $_POST))) {
						$logList[$level][$rule] += count($nnn);
						$hostList[$hostname] += count($nnn);
					}
				}
			}
		}
	} else {
		unlink($file);
	}
}
ksort($hostList);
krsort($logList);

$Index = new SimpleXMLElement($newArchivFilter);
$Index["count"] = 0;
$HostList = $Index->addChild("HostList");
	if (isset($_POST["HostList"]) && ($_POST["HostList"] == "HostList")) $HostList["select"] = "on";
#	if ((isset($_POST["HostList"]) && ($_POST["HostList"] == "HostList"))
#	|| (! in_array("Host", $_POST))) $HostList["select"] = "on";
$LogList = $Index->addChild("LogList");
	if (isset($_POST["LogList"]) && ($_POST["LogList"] == "LogList")) $LogList["select"] = "on";
#	if ((isset($_POST["LogList"]) && ($_POST["LogList"] == "LogList"))
#	|| (! in_array("Level", $_POST)) && (! in_array("Rule", $_POST))) $LogList["select"] = "on";
foreach ($hostList as $host=>$nnn) {
	$Host = $HostList->addChild("Host");
	$Host["name"] = $host;
	$Host["count"] += $nnn;
	if ($Host["count"] == 0) $Host["null"] = "null";
	if ((isset($_POST["HostList"]) && ($_POST["HostList"] == "HostList"))
	|| (isset($_POST[$host]) && ($_POST[$host] == "Host"))) $Host["select"] = "on";
}
foreach ($logList as $level=>$rules) {
	$Level = $LogList->addChild("Level");
	$Level["level"] = $level;
	$Level["alert"] = $alertLevel[$level];
	$Level["count"] = 0;
	foreach ($rules as $rule=>$nnn) {
		$Index["count"] += $nnn;
		$Level["count"] += $nnn;
		$Rule = $Level->addChild("Rule");
		$Rule["rule"] = $rule;
		$Rule["count"] = $nnn; 
		$Rule["groups"] = $ruleList[$rule]["groups"];
		$Rule["description"] = $ruleList[$rule]["description"];
		if ($Rule["count"] == 0) $Rule["null"] = "null";
		else if (isset($_POST[$rule])) $Rule["select"] = "on";
	}
	if ($Level["count"] == 0) $Level["null"] = "null";
	else if ((isset($_POST["LogList"]) && ($_POST["HostList"] == "LogList"))
	    || (isset($_POST["Level".$level]) && ($_POST["Level".$level] == "Level"))) $Level["select"] = "on";
}


#$Index["NOTE"] = $NOTE;
#$Index->asXML($xmlFileName);
header("Content-Type: text/xml");
echo $Index->asXML();

?>
