window.onload = function() {
	var maxUnitWidth = 0;
	var units = document.getElementsByName("unit");
	for (var i = 0; i < units.length; i++) {
		maxUnitWidth = Math.max(maxUnitWidth, units[i].scrollWidth);
	}
	for (var i = 0; i < units.length; i++) {
		units[i].style.width = maxUnitWidth + "px";
	}

	var elements = document.getElementsByTagName("input");
	for (var i = 0; i < elements.length; i++) {
		if (elements[i].type == "checkbox") {
			elements[i].onchange = function(event) { this.form.submit(); }
		}
	}
	resizeblank();
	window.onresize = function(event) { resizeblank(); }
}

function resizeblank() {
	var pageheader = document.getElementById("pageheader");
	var blank = document.getElementById("blank");	
	blank.style.height = pageheader.scrollHeight + "px";
}


