F=`ls -la /var/ossec/logs/alerts/*/*/*.log|egrep "\+ 2" | awk --field-separator=" " '{print $9}'`

FILELIST=`find /var/ossec/logs/alerts/*/ -type f -name "*.log" | egrep -v $F`

for i in $FILELIST 
do
	MD5=`md5sum $i | awk '{print $1}'`
	SHA1=`sha1sum $i | awk '{print $1}'`

	echo -e Current checksum: > "$i.sum"
	echo -e "MD5  ($i) = $MD5" >> "$i.sum"
	echo -e "SHA1 ($i) = $SHA1" >> "$i.sum"

	gzip -9 $i
done
