<?php
putenv("KRB5CCNAME={$_SERVER['KRB5CCNAME']}");
#echo print_r($_POST);
if ((! in_array("HostList", $_POST)) && (! in_array("Host", $_POST))) $_POST["HostList"] = "HostList";
if ((! in_array("LogList", $_POST)) && (! in_array("Level", $_POST))  && (! in_array("Rule", $_POST))) $_POST["LogList"] = "LogList";

$hosts = array_keys($_POST, "Host");
$levels = array_keys($_POST, "Level");
$rules = array_keys($_POST, "Rule");

$logFileName = "/var/ossec/logs/alerts/alerts.log";

?>
<html>
<head>
	<title>АРХИВ СОБЫТИЙ БЕЗОПАСНОСТИ ИНФОРМАЦИИ</title>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
	<link rel="stylesheet" type="text/css" href="ArchivFilter.css"/>
</head>
<body>
	<h1>АРХИВ СОБЫТИЙ БЕЗОПАСНОСТИ ИНФОРМАЦИИ</h1>
	<br/><h3>ЗАПРОС</h3><hr/>
	<table>
<?php
	echo "<tr><td class='right'>Выбраны устройства:</td><td class='bold'>";
	if (in_array("HostList", $_POST)) echo "ВСЕ";
	else if (count($hosts) > 0) {
		foreach ($hosts as $value) echo $value."&nbsp;&nbsp;&nbsp;";
	}
	echo "</td></tr>";
	if (in_array("LogList", $_POST)) {
		echo "</td></tr><tr><td class='right'>Выбраны уровни сообщений:</td><td class='bold'>ВСЕ</td>";
	}
	else if (count($levels) > 0) {
		echo "</td></tr><tr><td class='right'>Выбраны уровни сообщений:</td><td class='bold'>";
		foreach ($levels as $value) echo str_replace("Level", "", $value)."&nbsp;&nbsp;&nbsp;";
		echo "</td></tr>";
	}
	
	if (count($rules) > 0) {
		echo "</td></tr><tr><td class='right'>Выбраны виды сообщений:</td><td class='bold'>";
		foreach ($rules as $value) echo $value."&nbsp;&nbsp;&nbsp;";
		echo "</td></tr>";
	}
?>
	</td></tr>
	</table>
	<br/><h3>РЕЗУЛЬТАТЫ ЗАПРОСА</h3><hr/>
	<br><div class="printLog">
<?php
	#$logDirName = "/var/ossec/log/alerts";
	$logDirName = "/home/borisov/www/alerts";
	#$archDirName = "/var/www/ossec/data/";
	$indexDirName = "../arch";
	$alertsDirName = "/var/www/ossec/data/";
	$alertsDirName = "../data/";
	$alertsLevelFileName = "alerts.level";

	$alertLevel = array(0,1,1,1,1,1,2,2,2,2,2,3,3,3,3,3);
	if (is_readable($alertsDirName.$alertsLevelFileName)) {
		$alertLevel = unserialize(file_get_contents($alertsDirName.$alertsLevelFileName));
	}
	
	$ruleList = array();
	$hostList = array();
	$logList = array();
	$fileList = glob($indexDirName."/*.index");
	rsort($fileList);
	$numstr = 0;
	foreach ($fileList as $file) {
#echo "<br>".$file."<br>";
		$a = unserialize(file_get_contents($file));
		$printList = array();
		if (is_file($a["archiv"])) {
			if (isset($a["logs"])) foreach ($a["logs"] as $hostname=>$levelList) {
				if (in_array("HostList", $_POST) || array_key_exists($hostname, $_POST)) {
#echo "<br>hostname = ".$hostname;
					foreach ($levelList as $level=>$rules) {
						foreach ($rules as $rule=>$nnn) {
#echo "<br>level = ".$level." rule = ".$rule."<br>";
							if (in_array("LogList", $_POST)
							|| array_key_exists("Level".$level, $_POST)
							|| array_key_exists($rule, $_POST)) {
								$printList = array_merge($printList, $nnn);
							}
						}
					}
				}
			}
		}
		rsort($printList);
		if (count($printList > 0)) {
			if ($a["archiv"] == $logFileName) {
				$log = explode("** Alert ", file_get_contents($logFileName));
			} else { 
				$log = explode("** Alert ", implode("", gzfile($a["archiv"])));
			}
			foreach ($printList as $n) {
				$numstr += 1;
				echo "<p>".$numstr."</p>";
				$s = explode("(level", $log[$n]);
				$alert = explode(")", $s[1]);
				echo "<p class='alert-".$alertLevel[(int)$alert[0]]."'>"."** Alert ".nl2br($log[$n])."</p>";
			}
		}
		if ($numstr > 10000) break;
	}
?>
</div>
</body>
</html>
