<?php
putenv("KRB5CCNAME={$_SERVER['KRB5CCNAME']}");

#$_GET = array("host" => "qwerty", "log" => "2013-03-10_07");
#$_GET = array("host" => "*", "log" => "2013-03-10_00");
#$_GET = array("host" => "client", "log" => "*");
#$_GET = array("host" => "client", "log" => "");

$alertsDirName = "/var/www/ossec/data/";
#$alertsDirName = "../data/";
$xmlFileName = "ClearLogs.xml";

$newClearLogs = <<<XML
<?xml version='1.0' encoding='UTF-8'?>
<ClearLogs>
</ClearLogs>
XML;

$newClearLogs = <<<XML
<?xml version='1.0' encoding='UTF-8'?>
<?xml-stylesheet type="text/xsl" href="ClearLogs.xsl" media="screen"?>
<ClearLogs>
</ClearLogs>
XML;

#$a = serialize($_GET);

if (isset($_GET["command"])) {
	if ($_GET["command"] == "Снять с отображения") {
		if ($_GET["log"] == "") {
			$files = glob($alertsDirName.$_GET["host"]."/*.log");
			foreach ($files as $file) unlink($file);
			rmdir($alertsDirName.$_GET["host"]);
		} elseif ($_GET["log"] == "*") {
			$files = glob($alertsDirName.$_GET["host"]."/*.log");
			foreach ($files as $file) unlink($file);
		} elseif ($_GET["host"] == "*") {
			$dirs = glob($alertsDirName."*", GLOB_ONLYDIR);
			foreach ($dirs as $dir) {
				$files = glob($dir."/*.log");
				foreach ($files as $file) if (basename($file, ".log") <= $_GET["log"]) unlink($file);
			}
		} else {
			$files = glob($alertsDirName.$_GET["host"]."/*.log");
			foreach ($files as $file) if (basename($file, ".log") <= $_GET["log"]) unlink($file);
		}
	}
	unset ($_GET);
}

$Alert = array();
$HostAlert = array();
$HourAlert = array();
$hostDirs = glob($alertsDirName."*", GLOB_ONLYDIR);
foreach ($hostDirs as $hostDir) {
	$H = basename($hostDir);
	$HostAlert[$H] = 0;
	$logNames = glob($hostDir."/*.log");
	rsort($logNames);
	foreach ($logNames as $logName) {
		list($D, $h) = explode("_", basename($logName, ".log"));
		$logs = unserialize(file_get_contents($logName));
		$Alert[$H][$D][$h] = count($logs);
		if (isset($HostAlert[$H])) $HostAlert[$H] += count($logs);
		else $HostAlert[$H] = count($logs);
		if (isset($HourAlert[$D][$h])) $HourAlert[$D][$h] += count($logs);
		else $HourAlert[$D][$h] = count($logs);
	}
}

#$a = serialize($HostAlert);


$ClearLogs = new SimpleXMLElement($newClearLogs);
$ClearLogs["NOTE"] = serialize($a);
if (isset($_GET["host"])) $ClearLogs["host"] = $_GET["host"];
else $ClearLogs["host"] = "";
if (isset($_GET["log"])) $ClearLogs["log"] = $_GET["log"];
else $ClearLogs["log"] = "";

$Days = $ClearLogs->addChild("Days");
foreach ($HourAlert as $day=>$hours) {
	$Day = $Days->addChild("Day");
	$Day["date"] = $day;
	$Day["count"] = count($hours);
	foreach ($hours as $hour=>$logs) {
		$Hour = $Day->addChild("Hour");
		$Hour["hour"] = $hour;
		$Hour["logs"] = $logs;
		if (($day."_".$hour <= $_GET["log"])
		&& ($_GET["host"] == "*")) $Hour["del"] = "del";
	}
}
$Hosts = $ClearLogs->addChild("Hosts");
foreach ($HostAlert as $host=>$dayshours) {
	$Host = $Hosts->addChild("Host");
	$Host["host"] = $host;
	$Host["count"] = $HostAlert[$host];
	if (($_GET["log"] == "*") && ($host == $_GET["host"])) $Host["del"] = "del";
	if (($_GET["log"] == "") && ($host == $_GET["host"])) {
		$Host["del"] = "del";
		$Host["hostdel"] = "del";
	}
	foreach ($HourAlert as $day=>$hours) {
		$Day = $Host->addChild("Day");
		$Day["date"] = $day;
		foreach ($hours as $hour=>$logs) {
			$Hour = $Day->addChild("Hour");
			$Hour["hour"] = $hour;
			if (isset($Alert[$host][$day][$hour])) $Hour["logs"] = $Alert[$host][$day][$hour];
			else $Hour["logs"] = "";

			if (($day."_".$hour <= $_GET["log"]) && ($host == $_GET["host"])) $Hour["del"] = "del";
			if (($_GET["log"] == "*") && ($host == $_GET["host"])) $Hour["del"] = "del";
			if (($_GET["log"] == "") && ($host == $_GET["host"])) $Hour["del"] = "del";
			if (($day."_".$hour <= $_GET["log"]) && ($_GET["host"] == "*")) $Hour["del"] = "del";
		}
	}
}

#$ClearLogs->asXML($xmlFileName);
header("Content-Type: text/xml");
echo $ClearLogs->asXML();
?>

