<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template match="/">
     <xsl:apply-templates select="ClearLogs"/>
</xsl:template>

<xsl:template match="ClearLogs">
<html>
<head>
	<title>СНЯТИЕ С ОТОБРАЖЕНИЯ СОБЫТИЙ БЕЗОПАСНОСТИ ИНФОРМАЦИИ</title>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
	<_meta http-equiv="Refresh" content="3" url="ClearLogs.xml" target="_self"/>
	<link rel="stylesheet" type="text/css" href="ClearLogs.css"/>
</head>
<body>
	<form name="form" method="get" action="ClearLogs.php">
		<input type="hidden" name="host" value="{@host}"/>
		<input type="hidden" name="log" value="{@log}"/>
		<table><tr>
	<xsl:if test="((@host='') and (@log=''))">
		<td class="header">УКАЖИТЕ ДАННЫЕ РЕГИСТРАЦИИ СОБЫТИЙ<br/>
		ДЛЯ ПОСЛЕДУЮЩЕГО СНЯТИЯ С ОТОБРАЖЕНИЯ<br/>
		(Примечание: В log-файлах и в архивах события НЕ УДАЛЯЮТСЯ.)</td>
	</xsl:if>
	<xsl:if test="((@host!='') and (@host!='*') and (@log=''))">
		<td class="header"><input class="buttonyes" type="submit" name="command" value="Отменить"/></td>
		<td class="header">ПОДТВЕРДИТЕ СНЯТИЯ С ОТОБРАЖЕНИЯ <span class="bold">ВСЕХ</span> ДАННЫХ<br/>
		для устройства <span class="bold"><xsl:value-of select="@host"/></span>, включая каталог</td>
		<td class="header"><input class="buttonyes" type="submit" name="command" value="Снять с отображения"/></td>
	</xsl:if>
	<xsl:if test="((@host!='') and (@host!='*') and (@log='*'))">
		<td class="header"><input class="buttonyes" type="submit" name="command" value="Отменить"/></td>
		<td class="header">ПОДТВЕРДИТЕ СНЯТИЯ С ОТОБРАЖЕНИЯ <span class="bold">ВСЕХ</span> ДАННЫХ<br/>
		для устройства <span class="bold"><xsl:value-of select="@host"/></span></td>
		<td class="header"><input class="buttonyes" type="submit" name="command" value="Снять с отображения"/></td>
	</xsl:if>
	<xsl:if test="((@host='*') and (@log!='') and (@log!='*'))">
		<td class="header"><input class="buttonyes" type="submit" name="command" value="Отменить"/></td>
		<td class="header">ПОДТВЕРДИТЕ СНЯТИЯ С ОТОБРАЖЕНИЯ ВЫДЕЛЕННЫХ ДАННЫХ<br/>
		для <span class="bold">ВСЕХ</span> устройств от <span class="bold"><xsl:value-of select="@log"/></span> и ранее</td>
		<td class="header"><input class="buttonyes" type="submit" name="command" value="Снять с отображения"/></td>
	</xsl:if>
	<xsl:if test="((@host!='') and (@host!='*') and (@log!='') and (@log!='*'))">
		<td class="header"><input class="buttonyes" type="submit" name="command" value="Отменить"/></td>
		<td class="header">ПОДТВЕРДИТЕ СНЯТИЯ С ОТОБРАЖЕНИЯ ВЫДЕЛЕННЫХ ДАННЫХ<br/>
		для устройства <span class="bold"><xsl:value-of select="@host"/></span> от <span class="bold"><xsl:value-of select="@log"/></span> и ранее</td>
		<td class="header"><input class="buttonyes" type="submit" name="command" value="Снять с отображения"/></td>
	</xsl:if>
		</tr></table>
	</form>

	<table class="summary" cellspacing="4">
	<tr><th></th><th>День:</th>
	<xsl:for-each select="Days/Day">
		<td class="date bold" colspan="{@count}"><xsl:value-of select="@date"/></td>
		<th>День:</th>
	</xsl:for-each>
	</tr><tr><th></th><th>Часы:</th>
	<xsl:for-each select="Days/Day">
		<xsl:for-each select="Hour">
			<td class="date"><xsl:value-of select="@hour"/></td>
		</xsl:for-each>
		<th>Часы:</th>
	</xsl:for-each>
	</tr><tr><th></th><th>Всего:</th>
	<xsl:for-each select="Days/Day">
		<xsl:for-each select="Hour">
			<td class="summ {@del}">
			<a class="bold {@del}" href="ClearLogs.php?host=*&amp;log={../@date}_{@hour}" target="_self">
			<xsl:value-of select="@logs"/>
			</a></td>
		</xsl:for-each>
		<th>Всего:</th>
	</xsl:for-each>
	</tr>
	<xsl:for-each select="Hosts/Host">
		<tr>
		<th class="bold">
			<a class="bold {@hostdel}" href="ClearLogs.php?host={@host}" target="_self">
			<xsl:value-of select="@host"/>
		</a></th>
		<td class="summ {@del}">
		<a class="bold {@del}" href="ClearLogs.php?host={@host}&amp;log=*" target="_self">
			<xsl:value-of select="@count"/>
		</a></td>
		<xsl:for-each select="Day">
			<xsl:for-each select="Hour">
				<td class="{@del}">
				<a class="{@del}" href='ClearLogs.php?host={../../@host}&amp;log={../@date}_{@hour}' target='_self'>
				<xsl:value-of select="@logs"/>
				</a></td>
			</xsl:for-each>
			<th class="bold"><xsl:value-of select="../@host"/>:</th>
		</xsl:for-each>
		</tr>
	</xsl:for-each>
	</table>
</body>
</html>
</xsl:template>

</xsl:stylesheet>
